/*--------------------------------------------------------------------------
 *  Copyright 2008 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// utgb-core Project
//
// GenomeWindow.java
// Since: Jan 22, 2008
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/graphics/GenomeWindow.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.graphics;

public class GenomeWindow
{
    private final long startIndexOnGenome;
    private final long endIndexOnGenome;
    private long range;

    public GenomeWindow(long startIndexOnGenome, long endIndexOnGenome)
    {
        this.startIndexOnGenome = startIndexOnGenome;
        this.endIndexOnGenome = endIndexOnGenome;
        // inclusive
        range = this.endIndexOnGenome - this.startIndexOnGenome + 1;
        if(range <= 0)
        	range = 1;
    }

    public int getXPosOnWindow(long indexOnGenome, int canvasWidth)
    {
        double v = (indexOnGenome - startIndexOnGenome) * (double) canvasWidth;
        double v2 = v / (double) range;
        return (int) v2;
    }
}
