/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// Icon.java
// Since: Jun 21, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/utgb/client/ui/Icon.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.utgb.client.ui;

import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.MouseListener;
import com.google.gwt.user.client.ui.Widget;


public class Icon extends Image implements MouseListener {
	IconImage _icon;

	public Icon(IconImage icon) {
		super(icon.getImageURL());
		_icon = icon;
		
		addMouseListener(this);
	}

	public void setIcon(IconImage newIcon)
	{
		_icon = newIcon;
		setUrl(_icon.getImageURL());
	}
	
	public void onMouseDown(Widget sender, int x, int y) {

	}

	public void onMouseEnter(Widget sender) {
		setUrl(_icon.getMouseOverImageURL());
	}

	public void onMouseLeave(Widget sender) {
		setUrl(_icon.getImageURL());
	}

	public void onMouseMove(Widget sender, int x, int y) {

	}

	public void onMouseUp(Widget sender, int x, int y) {

	}
	

}
