/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// DatabaseServiceImpl.java
// Since: Jul 2, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/utgb/server/db/DatabaseServiceImpl.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.utgb.server.db;

import java.util.ArrayList;
import java.util.List;

import org.utgenome.UTGBException;
import org.utgenome.gwt.utgb.client.db.DatabaseService;
import org.utgenome.gwt.utgb.client.track.bean.LegacyTrackInformation;
import org.utgenome.gwt.utgb.server.UTGBMaster;
import org.xerial.db.DBException;
import org.xerial.db.sql.DatabaseAccess;
import org.xerial.db.sql.SQLExpression;
import org.xerial.util.log.Logger;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;

public class DatabaseServiceImpl extends RemoteServiceServlet implements DatabaseService
{

    private static Logger _logger = Logger.getLogger(DatabaseServiceImpl.class);

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    public String getCatalog()
    {
        // TODO Auto-generated method stub
        return null;
    }

    public List getDatabaseLocation(String path)
    {
        // TODO Auto-generated method stub
        return null;
    }

    public String query(String path, String jsonQuery)
    {
        // TODO Auto-generated method stub
        return null;
    }

    public List getAvailableSpecies()
    {
        ArrayList<String> speciesList = new ArrayList<String>();
        try
        {
            DatabaseAccess sqlite = UTGBMaster.getDatabaseAccess("legacy-track");
            List<String> queryResult = sqlite.singleColumnQuery("select distinct species from tracks order by species",
                    "species", String.class);
            _logger.debug("species: " + queryResult);
            speciesList.addAll(queryResult);
        }
        catch (DBException e)
        {
            _logger.error(e);
        }
        catch (UTGBException e)
        {
            _logger.error(e);
        }
        return speciesList;
    }

    public List getSequenceRevision(String species)
    {
        ArrayList<String> revisionList = new ArrayList<String>();
        try
        {
            DatabaseAccess sqlite = UTGBMaster.getDatabaseAccess("legacy-track");
            List<String> queryResult = sqlite.singleColumnQuery(SQLExpression.fillTemplate(
                    "select distinct revision from tracks where species=\"$1\" order by revision", species),
                    "revision", String.class);
            _logger.debug("revision: " + queryResult);
            for (Object r : queryResult)
                revisionList.add(r.toString());
        }
        catch (DBException e)
        {
            _logger.error(e);
        }
        catch (UTGBException e)
        {
            _logger.error(e);
        }

        return revisionList;
    }

    public List getLegacyTrackList(String species, String sequenceRevision)
    {
        _logger.debug("get legaty track list: " + species + ", " + sequenceRevision);
        ArrayList<LegacyTrackInformation> legacyTrackList = new ArrayList<LegacyTrackInformation>();
        try
        {
            DatabaseAccess sqlite = UTGBMaster.getDatabaseAccess("legacy-track");
            List<LegacyTrackInformation> queryResult = sqlite
                    .query(
                            SQLExpression
                                    .fillTemplate(
                                            "select name, descriptionXML, docURL from tracks where species=\"$1\" and revision=\"$2\" order by revision",
                                            species, sequenceRevision), LegacyTrackInformation.class);
            legacyTrackList.addAll(queryResult);
        }
        catch (DBException e)
        {
            _logger.error(e);
        }
        catch (UTGBException e)
        {
            _logger.error(e);
        }

        return legacyTrackList;

    }

}
