/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// BooleanType.java
// Since: 2007/04/13
//
// $Date: 2007-12-27 14:27:01 +0900 (木, 27 12 2007) $
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/db/datatype/BooleanType.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.db.datatype;

import com.google.gwt.json.client.JSONBoolean;
import com.google.gwt.json.client.JSONValue;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.KeyboardListener;
import com.google.gwt.user.client.ui.Widget;

public class BooleanType extends DataTypeBase {

	public BooleanType(String name) {
		super(name);
	}

	public InputForm getInputForm() {
		return new BooleanTypeForm();
	}

	public class BooleanTypeForm extends InputForm
	{
		CheckBox form = new CheckBox();

		public BooleanTypeForm()
		{
			initWidget(form);
		}
		
		public String getUserInput() {
			return form.isChecked() ? "true" : "false";
		}

		public JSONValue getJSONValue() {
			return JSONBoolean.getInstance(form.isChecked());
		}

		public void setValue(String value) {
			if(value.equals("true"))
				form.setChecked(true);
			else
				form.setChecked(false);
		}

	
		public void addKeyboardListener(KeyboardListener listener) {
			form.addKeyboardListener(listener);
		}

		public void addChangeListener(final ChangeListener listener) {
			form.addClickListener(new ClickListener() {
				public void onClick(Widget sender) {
					listener.onChange(form);
				}}
			);
			
		}

	}

	public String toString(JSONValue json) {
		JSONBoolean b = json.isBoolean();
		if(b == null)
			return super.toString(json);
		else
			return b.booleanValue() ? "true" : "false";
	}

	public String getTypeName() {
		return "boolean";
	}
	


}




