/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// DoubleType.java
// Since: 2007/04/13
//
// $Date: 2007-12-27 14:27:01 +0900 (木, 27 12 2007) $
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/db/datatype/DoubleType.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.db.datatype;

import com.google.gwt.core.client.GWT;
import com.google.gwt.json.client.JSONNumber;
import com.google.gwt.json.client.JSONString;
import com.google.gwt.json.client.JSONValue;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.KeyboardListener;
import com.google.gwt.user.client.ui.TextBox;

public class DoubleType extends DataTypeBase 
{
	public DoubleType(String name)
	{
		super(name);
	}
	

	public InputForm getInputForm() {
		return new DoubleTypeForm();
	}

	public class DoubleTypeForm extends InputForm
	{
		private TextBox form = new TextBox();
		public DoubleTypeForm() 
		{
			initWidget(form);
		}

		public String getUserInput() {
			return form.getText();
		}

		public JSONValue getJSONValue() {
	        try
	        { 
	            double value = Double.parseDouble(form.getText());
	            return new JSONNumber(value);
	        }
	        catch(NumberFormatException e)
	        {
	            return new JSONString("");
	        }
		}

		public void setValue(String value) {
			try
			{
				double v = Double.parseDouble(value);
				form.setText(value);
			}
			catch(NumberFormatException e)
			{
				GWT.log(value + " is not a double type", e);
			}
		}

		public void addKeyboardListener(KeyboardListener listener) {
			form.addKeyboardListener(listener);
		}

		public void addChangeListener(ChangeListener listener) {
			form.addChangeListener(listener);
		}
	}

	public String getTypeName() {
		return "double";
	}


	
}




