/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// InputForm.java
// Since: 2007/04/13
//
// $Date: 2007-12-27 14:27:01 +0900 (木, 27 12 2007) $
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/db/datatype/InputForm.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.db.datatype;

import com.google.gwt.json.client.JSONValue;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.KeyboardListener;

/**
 * {@link InputForm} is an interface of input forms of various data types.
 * 
 * @author leo
 * 
 */
public abstract class InputForm extends Composite {
	public abstract String getUserInput();
	public abstract void setValue(String value);
	public abstract JSONValue getJSONValue();
	public abstract void addKeyboardListener(KeyboardListener listener);
	public abstract void addChangeListener(ChangeListener listener);
}
