/*--------------------------------------------------------------------------
 *  Copyright 2004 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ
//
// PageManager.java
// Since: 2005/07/21 1:42:44
//
// $URL: http://www.xerial.org/svn/project/XerialJ/trunk/xerial-storage/src/main/java/org/xerial/mlpress/PageManager.java $
// $Author: leo $
//--------------------------------------
package org.xerial.mlpress;


/**
 * PageManager allocates fixed-size PageBlocks
 * 
 * @author leo
 *
 */
public class PageManager
{
    private int _pageSize;
    
    /**
     * 
     */
    public PageManager(int pageSize)
    {
        _pageSize = pageSize;
    }
    
    PageBlock allocateEmptyPage()
    {
        return new PageBlock(_pageSize, PageType.EMPTY);
    }
}
